const state = {
    currencies: [],
    loadingCurrencies: true,
    selectedCurrency: null
}

const getters = {
    /**
     * 
     * @param {*} state 
     */
    currencies(state) {
        return state.currencies
    },
    /**
     * 
     * @param {*} state 
     */
    loadingCurrencies(state) {
        return state.loadingCurrencies
    },
    /**
     * 
     */
    selectedCurrency(state) {
        return state.selectedCurrency
    }
}

const mutations = {
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    setCurrencies(state, payload) {
        state.currencies = [...payload]
    },
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    setLoadingCurrencies(state, payload) {
        state.loadingCurrencies = !!payload
    },
    /**
     * 
     * @param {*} state 
     */
    autoSelectCurrency(state) {
        state.selectedCurrency = state.currencies.find(item => item.base == true)
    }
}

const actions = {
    /**
     * 
     * @param {*} param0 
     * @param {*} payload 
     */
    initCurrencies({ commit }, payload) {
        commit('setCurrencies', payload)
        commit('autoSelectCurrency')
        commit('setLoadingCurrencies', false)
    },
    /**
     * 
     * @param {*} param0 
     */
    resetCurrency({ commit }, payload) {
        commit('setLoadingCurrencies', true)
        commit('setCurrencies', [])
    }
}

export default {
    state,
    getters,
    mutations,
    actions
}